



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Spring IOC容器启动流程源码解析(一)——容器概念详解及源码初探</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Spring IOC容器启动流程源码解析(一)——容器概念详解及源码初探</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-08 02:59:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><div>
<div>目录</div>
<ul><li><a href="#11-ioc容器到底是什么" rel="external nofollow noreferrer">1.1 IOC容器到底是什么</a></li>
<li><a href="#12-beanfactory和applicationcontext的联系以及区别" rel="external nofollow noreferrer">1.2 BeanFactory和ApplicationContext的联系以及区别</a></li>
<li><a href="#13-解读ioc容器启动流程的意义" rel="external nofollow noreferrer">1.3 解读IOC容器启动流程的意义</a></li>
<li><a href="#14-如何有效的阅读源码" rel="external nofollow noreferrer">1.4 如何有效的阅读源码</a></li></ul>
</div>
<h3>1.1 IOC容器到底是什么</h3>
<p>IOC和AOP是Spring框架的核心功能,而IOC又是AOP实现的基础,因而可以说IOC是整个Spring框架的基石。那么什么是IOC？IOC即控制反转,通俗的说就是让Spring框架来帮助我们完成对象的依赖管理和生命周期控制等等工作。从面向对象的角度来说,具有这种行为,完成这种工作的主体就可以形象的称之为IOC容器。从代码角度来看,IOC容器不过是Spring中定义的具有IOC基本功能的一些类的统称,这些类都遵循一些共同的接口规范,所以我们可以说实现某些接口的具体的实现类就是IOC容器。而IOC容器的启动流程,说白了就是创建并初始化一个该实现类的实例的过程,在这个过程中要进行诸如配置文件的加载解析,核心组件的注册,bean 实例的创建等一系列繁琐复杂的操作,因而整个过程显得相对漫长,逻辑也相对复杂。</p>
<h3>1.2 BeanFactory和ApplicationContext的联系以及区别</h3>
<p>前面说到Spring中为容器类定义了一些接口规范,如下图所示<br /><br />
<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1422237/201810/1422237-20181008215817959-1853766918.png"></p>
<p>具体而言,Spring中的容器类可以分为两大类。</p>
<ul><li><p>一类是由BeanFactory接口定义的核心容器。BeanFactory位于整个容器类体系结构的顶端,其基本实现类为DefaultListableBeanFactory。之所以称其为核心容器,是因为该类容器实现IOC的核心功能:比如配置文件的加载解析,Bean依赖的注入以及生命周期的管理等。BeanFactory作为Spring框架的基础设施,面向Spring框架本身,一般不会被用户直接使用。</p></li>
<li><p>另一类则是由ApplicationContext接口定义的容器,通常译为应用上下文,不过称其为应用容器可能更形象些。它在BeanFactory提供的核心IOC功能之上作了扩展。通常ApplicationContext的实现类内部都持有一个BeanFactory的实例,IOC容器的核心功能会交由它去完成。而ApplicationContext本身,则专注于在应用层对BeanFactory作扩展,比如提供对国际化的支持,支持框架级的事件监听机制以及增加了很多对应用环境的适配等。ApplicationContext面向的是使用Spring框架的开发者。开发中经常使用的ClassPathXmlApplicationContext就是典型的Spring的应用容器,也是要进行解读的IOC容器。</p></li></ul>
<h3>1.3 解读IOC容器启动流程的意义</h3>
<ul><li><p>1.IOC模块是整个Spring框架的核心,是实现其他模块的基础。IOC容器在启动时会注册并初始化Spring框架的所有基础组件,这些组件不仅在IOC模块中被用到,也会被AOP等模块使用。因而熟悉IOC容器的启动流程不仅是掌握IOC模块的关键,也是理解整个Spring框架的前提。</p></li>
<li><p>2.Spring是个很灵活的框架,允许用户在原有功能上进行扩展或者进行满足业务需求的个性化设置,比如对容器和Bean的生命周期过程进行增强,进行事件监听等等。要更好的使用Spring的这些特性,必须了解其工作原理,而答案就在IOC容器的启动过程中。</p></li>
<li><p>3.Spring框架在实现时使用了大量的设计模式,体现了很多优秀的设计思想。其IOC容器的启动源码就是供开发者学习这种设计经验的绝佳样板。</p></li></ul>
<p>长求总:为了更好的理解和使用Spring框架并从它优秀的设计和实现经验中进行学习。</p>
<h3>1.4 如何有效的阅读源码</h3>
<p>Spring框架经过多年的发展,随着功能特性的增加,其实现也越来越复杂和抽象,要彻底弄清楚框架实现的每一个细节并不是一件简单的事。因而,对于Spring源码的解读,不必死抠每个方法和实现细节,这样太浪费时间,毕竟对于绝大分开发者而言,阅读Spring源码并不是为了成为Spring框架的开发者,而是为了更好的理解和使用Spring框架,或者从更高的角度,学习Spring的设计经验和思想,并将其运用到自己的项目实践中。<br /><br />
由于Spring容器的启动流程十分冗长,内容实在太多,全部放在一篇进行讲解实在太臃肿,也十分影响阅读体验。因而采取化整为零的策略,将整个IOC容器的启动流程划分为若干个阶段,每篇只对其中一个阶段进行详细讲解,因而对于容器启动源码的解读,主要抓住以下两个要点：</p>
<ul><li><p>1.对容器启动流程的梳理<br /><br />
容器启动流程分为哪几个阶段,在每个阶段容器做了哪些工作,初始化了哪些组件,执行了哪些用户自定义的回调函数。</p></li>
<li><p>2.对设计模式和设计思想的学习<br /><br />
在实现这个功能时采用了哪些设计模式,遵循了哪些设计思想,这么做有哪些好处。</p></li></ul>
<h2>2. 初探IOC容器启动源码</h2>
<p>本次源码阅读的Spring版本为4.3.10.RELEASE。</p>
<p>启动Spring容器,本质上是创建并初始化一个具体的容器类的过程,以常见的容器类ClassPathXmlApplicationContext为例,启动一个Spring容器可以用以下代码表示</p>
<pre class="prettyprint linenums"><code>ClassPathXmlApplicationContext ctx = new ClassPathXmlApplicationContext(&quot;applicationContext.xml&quot;);<br />
</code></pre>
<p>尽管只有短短的一行代码,但已经创建并启动了一个Spring的IOC容器。为了后面更好的理解,先来看下ClassPathXmlApplicationContext的类继承结构<br /><br />
<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1422237/201810/1422237-20181008215837775-355870697.png"></p>
<p>关键的几个类已经用红色箭头标注了出来。</p>
<ul><li><p>AbstractApplicationContext<br /><br />
ApplicationContext接口的抽象实现类,能够自动检测并注册各种后置处理器(PostProcessor)和事件监听器(Listener),以模板方法模式定义了一些容器的通用方法,比如启动容器的真正方法refresh()就是在该类中定义的。</p></li>
<li><p>AbstractRefreshableApplicationContext<br /><br />
继承AbstractApplicationContext的抽象类。内部持有一个DefaultListableBeanFactory 的实例,使得继承AbstractRefreshableApplicationContext的Spring的应用容器内部默认有一个Spring的核心容器,那么Spring容器的一些核心功能就可以委托给内部的核心容器去完成。AbstractRefreshableApplicationContext在内部定义了创建,销毁以及刷新核心容器BeanFactory的方法。</p></li>
<li><p>ClassPathXmlApplicationContext<br /><br />
最常用的Spring的应用容器之一。在启动时会加载类路径下的xml文件作为容器的配置信息。</p></li></ul>
<p>下面就正式开始容器启动流程的源码阅读<br /><br />
进入ClassPathXmlApplicationContext的构造方法,首先调用了重载构造函数</p>
<pre class="prettyprint linenums"><code>/**<br />
 * Create a new ClassPathXmlApplicationContext, loading the definitions<br />
 * from the given XML file and automatically refreshing the context.<br />
 * @param configLocation resource location<br />
 * @throws BeansException if context creation failed<br />
 */<br />
public ClassPathXmlApplicationContext(String configLocation) throws BeansException {<br />
   this(new String[] {configLocation}, true, null);<br />
}<br />
</code></pre>
<p>这里有两点需要注意下:</p>
<ul><li>1.创建ClassPathXmlApplicationContext时需要指定xml文件的路径作为参数,尽管我们在创建时只指定了一个,但其实可以同时指定多个。</li>
<li>2.Spring容器有父子容器的概念,通过HierarchicalBeanFactory接口定义了具有层级关系的容器体系。而在抽象实现类AbstractApplicationContext类的内部,有一个表示父容器的成员变量</li></ul>
<pre class="prettyprint linenums"><code>/** Parent context */<br />
private ApplicationContext parent;

</code></pre>
<p>重载函数的第三个参数即表示要创建的ClassPathXmlApplicationContext的父容器,不过这里只需要设置为null。关于Spring的父子容器,还有一些独特的访问规则,子容器可以访问父容器中的Bean,父容器不可以访问子容器中的Bean。不知道这个规则在使用Spring做web开发时可能会碰到一些匪夷所思的问题。</p>
<p>继续跟进源码</p>
<pre class="prettyprint linenums"><code>//设置父容器<br />
super(parent);<br />
//设置xml文件的路径参数<br />
setConfigLocations(configLocations);<br />
if (refresh) { //默认为true<br />
    //启动Spring容器<br />
    refresh();<br />
}<br />
</code></pre>
<p>设置完父容器和xml文件的路径信息后,终于看到了refresh()方法,正如前面提到的,这是真正启动Spring容器的方法,想要知道Spring IOC容器的启动流程,就要知道该方法内部都做了什么。</p>
<h3>2.1 启动容器的真正入口refresh()</h3>
<p>refresh()是定义在AbstractApplicationContext类中的模板方法,定义了容器启动的基本流程,并留下钩子方法供子类进行扩展。</p>
<pre class="prettyprint linenums"><code>@Override<br />
public void refresh() throws BeansException, IllegalStateException {<br />
   synchronized (this.startupShutdownMonitor) {<br />
      // Prepare this context for refreshing.<br />
      prepareRefresh();

      // Tell the subclass to refresh the internal bean factory.<br />
      ConfigurableListableBeanFactory beanFactory = obtainFreshBeanFactory();

      // Prepare the bean factory for use in this context.<br />
      prepareBeanFactory(beanFactory);

      try {<br />
         // Allows post-processing of the bean factory in context subclasses.<br />
         postProcessBeanFactory(beanFactory);

         // Invoke factory processors registered as beans in the context.<br />
         invokeBeanFactoryPostProcessors(beanFactory);

         // Register bean processors that intercept bean creation.<br />
         registerBeanPostProcessors(beanFactory);

         // Initialize message source for this context.<br />
         initMessageSource();

         // Initialize event multicaster for this context.<br />
         initApplicationEventMulticaster();

         // Initialize other special beans in specific context subclasses.<br />
         onRefresh();

         // Check for listener beans and register them.<br />
         registerListeners();

         // Instantiate all remaining (non-lazy-init) singletons.<br />
         finishBeanFactoryInitialization(beanFactory);

         // Last step: publish corresponding event.<br />
         finishRefresh();<br />
      }

      catch (BeansException ex) {<br />
         if (logger.isWarnEnabled()) {<br />
            logger.warn(&quot;Exception encountered during context initialization - &quot; +<br />
                  &quot;cancelling refresh attempt: &quot; + ex);<br />
         }

         // Destroy already created singletons to avoid dangling resources.<br />
         destroyBeans();

         // Reset 'active' flag.<br />
         cancelRefresh(ex);

         // Propagate exception to caller.<br />
         throw ex;<br />
      }

      finally {<br />
         // Reset common introspection caches in Spring's core, since we<br />
         // might not ever need metadata for singleton beans anymore...<br />
         resetCommonCaches();<br />
      }<br />
   }<br />
}

</code></pre>
<p>启动容器的方法之所以用refresh(刷新)来命名,是为了形象的表达容器可以被重启这层含义。为了防止并发环境下多个线程同时启动IOC容器,整个过程使用同步代码块来进行同步。容器的启动从方法内容上来看并不复杂,流程也十分清晰,从方法名上大概就可以猜到每一步做了什么。</p>
<h3>2.2 容器启动流程的不同阶段</h3>
<p>为了更好的进行讲解,可以将容器启动的整个流程划分为以下五个阶段<br /><br />
<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1422237/201810/1422237-20181009142607492-65989011.png"></p>
<h2>3 容器启动前的准备工作</h2>
<p>容器启动前的准备工作定义在下面的方法中</p>
<pre class="prettyprint linenums"><code>prepareRefresh();

</code></pre>
<p>进去一探究竟</p>
<pre class="prettyprint linenums"><code>/**<br />
 * Prepare this context for refreshing, setting its startup date and<br />
 * active flag as well as performing any initialization of property sources.<br />
 */<br />
protected void prepareRefresh() {<br />
    //记录容器的启动时间<br />
    this.startupDate = System.currentTimeMillis();<br />
    //将容器的关闭标志置位false<br />
    this.closed.set(false);<br />
    //将容器的启动标记置位true<br />
    this.active.set(true);

    if (logger.isInfoEnabled()) {<br />
        logger.info(&quot;Refreshing &quot; + this);<br />
    }

    // Initialize any placeholder property sources in the context environment<br />
    //空实现的钩子方法,供子类重写<br />
    initPropertySources();

    // Validate that all properties marked as required are resolvable<br />
    // see ConfigurablePropertyResolver#setRequiredProperties<br />
    //对必须的系统环境变量进行校验,如果不存在将抛出异常<br />
    getEnvironment().validateRequiredProperties();

    // Allow for the collection of early ApplicationEvents,<br />
    // to be published once the multicaster is available...<br />
    this.earlyApplicationEvents = new LinkedHashSet&lt;ApplicationEvent&gt;();<br />
}

</code></pre>
<p>首先记录了容器的启动时间和对容器的状态进行了标记。之后来到了容器为用户提供的第一个扩展点:</p>
<pre class="prettyprint linenums"><code>initPropertySources();<br />
</code></pre>
<pre class="prettyprint linenums"><code>protected void initPropertySources() {<br />
   // For subclasses: do nothing by default.<br />
}

</code></pre>
<p>这是一个默认空实现的钩子方法,用户在自定义IOC容器时可以重写,完成一些环境变量属性的初始化工作。<br /><br />
之后会对一些必要的环境变量信息进行校验</p>
<pre class="prettyprint linenums"><code>getEnvironment().validateRequiredProperties();

</code></pre>
<p>如果必须的环境变量信息不存在,则会抛出异常</p>
<pre class="prettyprint linenums"><code>@Override<br />
public void validateRequiredProperties() {<br />
   MissingRequiredPropertiesException ex = new MissingRequiredPropertiesException(); //异常信息集合<br />
   for (String key : this.requiredProperties) {<br />
      if (this.getProperty(key) == null) {<br />
         ex.addMissingRequiredProperty(key); //加入异常信息<br />
      }<br />
   }<br />
   if (!ex.getMissingRequiredProperties().isEmpty()) {<br />
      throw ex;  //抛出异常信息集合<br />
   }<br />
}<br />
</code></pre>
<p>结合前面的钩子initPropertySources(),用户在自定义IOC容器时可以完成一些个性化需求,比如要求容器在启动时必须从环境变量中加载某属性值,若该属性值不存在则启动失败。重写initPropertySources()如下</p>
<pre class="prettyprint linenums"><code>@Override<br />
protected void initPropertySources() {<br />
    getEnvironment().setRequiredProperties(&quot;XXXX&quot;);<br />
}<br />
</code></pre>
<p>若环境变量不存在则会抛出以下异常</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1422237/201810/1422237-20181008220021522-1384464423.png"></p>
<p>总结下容器启动前的准备工作:主要是对容器状态进行标记,初始化环境变量信息并对必要的环境变量进行校验。</p>
<h2>4. 总结</h2>
<p>这篇文章的主要内容</p>
<ul><li>1.讲解IOC容器的概念和类结构</li>
<li>2.找到容器启动流程的真正入口refresh()方法,将容器启动流程划分为了5个阶段:启动前的准备阶段,初始化核心容器阶段,初始化基础组件阶段,创建单实例bean阶段以及容器启动的收尾阶段</li>
<li>3.对容器启动前的准备阶段进行了源码解读</li></ul>
<p>可以看到容器启动源码中对模板方法模式的合理运用。容器启动的流程以模板方法模式定义在了抽象容器类AbstractApplicationContext中,并留下了钩子函数供子类重写。用户实现自定义容器时,可以通过继承并重写钩子函数的方法对原有容器的功能进行扩展,而无需多做其他改动。这样既为用户扩展Spring容器开放了接口,又为用户屏蔽了容器实现的复杂性,很好的实现了Spring容器通用性和扩展性的统一。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlmoy09.html">Elasticsearch 调优 （官方文档How To）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mwv26q.html">【转载】&period;NET模拟POST登录并保持登录状态</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq40zwj8.html">clientHeight&comma;offsetHeight与scrollHeight的相关知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd25pz9.html">Struts2学习笔记-基本结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2oyox9.html">http技术交流提纲</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qypnndq.html">wp8</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdz01m8.html">Limit the query running time with Resource limit facility &lpar;RLF&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k10lp69.html">xtjh</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wmg3xq.html">FTP没权限直接删除目录，写的一个小工具循环删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxne3xj8.html">upTodown</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmzmrl9.html">struts2&period;1笔记04：struts2优点</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpk25xq.html">【NO&period;11】Jmeter - 构建1个可供Linux使用的Jmeter测试脚本 - 共3个步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy17n0jq.html">python 基础语法梳理（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kg2w49.html">Acrobat Pro DC 2019 mac中文版&lpar;pdf编辑器&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1y5leq.html">day14 十四、三元运算符，推导式，匿名内置函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy65w39.html">JVM内存区域详解（Eden Space、Survivor Space、Old Gen、Code Cache和Perm Gen）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx22vjz8.html">Business vs Technology</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj2vxjq.html">Dubbo实践（九）ExtensionFactory</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwolojk9.html">【题解】洛谷P1514 &lbrack;NOIP2010TG&rsqb; 引水入城（DFS&plus;DP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4475xnq.html">3---Django rest framework源码分析（3）----节流</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8o4rxmeq.html">&lpar;转&rpar;OAuth 2&period;0的设计思路</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvem5xj9.html">ps cs6破解</a>
			</li>
						<li><a href="https://www.batexi.com/a/963wojj9.html">NameError&colon; name &amp;&num;39&semi;picamera&amp;&num;39&semi; is not defined</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o40jv1q.html">Ambiguous reference to member &amp;&num;39&semi;dataTask&lpar;with&colon;completionHandle&colon;&rpar;&amp;&num;39&semi;错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnr5zeq.html">laravel 创建自定义全局函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/902xrmoq.html">python api接口认证脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/953kpyz8.html">windows server 2008 HPC Edtion激活教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnzdx3q.html">【linux】Linux系统信息查看命令大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj7loo8.html">对widget使用WM&lowbar;SetCallback</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj7p568.html">MySQL 多表关联更新及删除</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
